﻿Imports Infragistics.Win.UltraWinGrid
Imports System.Windows.Forms



Public Class UltraGridUddMouseWheelHack


    Public mUgrid As UltraGrid

    Private mUddSavedValueForMouseWheelHack As Object


    Public Sub InigUltraGridUddMouseWheelHack()
        AddHandler Me.mUgrid.ControlAdded, AddressOf Me.mUGrid_ControlAdded
    End Sub


    Private Sub mUGrid_ControlAdded(ByVal sender As Object, ByVal e As ControlEventArgs)
        'Dim contType As String = sender.GetType().ToString()
        Dim uGrid As UltraGrid = DirectCast(sender, UltraGrid)
        Dim udd As UltraDropDown = TryCast(uGrid.ActiveCell.ValueListResolved, UltraDropDown)

        If (udd IsNot Nothing) Then
            AddHandler e.Control.MouseWheel, AddressOf mUGrid_uddControl_MouseWheel
            AddHandler e.Control.KeyUp, AddressOf mUGrid_uddControl_KeyUp
            AddHandler e.Control.Enter, AddressOf mUGrid_uddControl_Enter
            AddHandler udd.AfterCloseUp, AddressOf mUGrid_uddControl_AfterCloseUp
        End If

    End Sub


    Private Sub SaveUltraDropDownSelectedValue()
        '_dropdownValue = Me.mUGrid.ActiveCell.Value     'this one is wrong, when dthe dropdown close up, the activecell.value is still the old value; the grid update it later; so we need to picku up the corret value somwhere else (see down)

        If Me.mUgrid.ActiveCell IsNot Nothing AndAlso Me.mUgrid.ActiveCell.ValueListResolved IsNot Nothing Then
            mUddSavedValueForMouseWheelHack = Me.mUgrid.ActiveCell.ValueListResolved.GetValue(Me.mUgrid.ActiveCell.ValueListResolved.SelectedItemIndex)
        End If
    End Sub


    Private Sub mUGrid_uddControl_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs)
        'this tack the value change due to keyboard interaction
        SaveUltraDropDownSelectedValue()
    End Sub



    Private Sub mUGrid_uddControl_AfterCloseUp(ByVal sender As Object, ByVal e As DropDownEventArgs)
        'this tack the selected value on dropdown close-up
        SaveUltraDropDownSelectedValue()
    End Sub



    Private Sub mUGrid_uddControl_Enter(ByVal sender As Object, ByVal e As EventArgs)
        'save the current value, used in case the user don't change the current value, but still use the mouse wheel

        Dim senderControl As Control = DirectCast(sender, Control)
        Dim uGrid As UltraGrid = TryCast(senderControl.Parent, UltraGrid)

        If (uGrid IsNot Nothing) Then
            Dim dropdown As UltraDropDown = TryCast(uGrid.ActiveCell.ValueListResolved, UltraDropDown)

            If (dropdown IsNot Nothing) Then
                mUddSavedValueForMouseWheelHack = uGrid.ActiveCell.Value
            End If

        End If

    End Sub




    Private Sub mUGrid_uddControl_MouseWheel(ByVal sender As Object, ByVal e As MouseEventArgs)
        Dim conSender As Control = DirectCast(sender, Control)
        Dim ugSender As UltraGrid = DirectCast(conSender.Parent, UltraGrid)


        If (ugSender IsNot Nothing) Then

            Dim dropdown As UltraDropDown = TryCast(ugSender.ActiveCell.ValueListResolved, UltraDropDown)

            If (dropdown IsNot Nothing) AndAlso (Not dropdown.IsDroppedDown) Then

                'we need to restore the saved value because when this event handler is called, the 
                'udd current value has ALREADY been changed by this event, and this is exactly what mustn't happen
                ugSender.ActiveCell.Value = mUddSavedValueForMouseWheelHack

                'from now-on, the mouse wheel will scroll the grid :-)
                ugSender.PerformAction(UltraGridAction.ExitEditMode, False, False)

            End If

        End If

    End Sub

End Class
